Subject: [clisp-list] [comp.lang.lisp] Gtk bindings for CMUCL/CLISP

From: Sam Steingold <[email-masked]>
Date: 15 Mar 2000 10:53:22 -0500

The appended message answers one of the most popular clisp survey
(http://sourceforge.net/survey/survey.php?group_id=1355&survey_id=10073)
feature requests - for a GUI development tool.

While CLISP already comes with (2 implementations of) CLX, it is
considered too low-level for easy development.

If there is a sufficient user demand, the developers might think of
discussing the idea of considering talking about trying to integrate clg
into the standard clisp distribution. :-)

-- 
Sam Steingold (http://www.podval.org/~sds)
Micros**t is not the answer.  Micros**t is a question, and the answer is Linux,
(http://www.linux.org) the choice of the GNU (http://www.gnu.org) generation.
Bill Gates is great, as long as `bill' is a verb.

------- Start of forwarded message -------
Newsgroups: comp.lang.lisp
From: Espen S Johnsen <[email-masked]>
Subject: Gtk bindings for CMUCL/CLISP
Organization: -
Message-ID: <[email-masked]>
References: <[email-masked]> <[email-masked]> <[email-masked]> <[email-masked]> <[email-masked]>
Date: Tue, 14 Mar 2000 21:07:52 GMT

I writes:

> Hannu Koivisto <[email-masked]> writes:
> 
> > Here's another one for 1.2: <URL:ftp://ftp.sol.no/users/e/espejohn/>.
> 
> Unfornately my ISP has closed anonymous FTP so this URL is no longer
> valid. I will try to make it available throught HTTP in a few days. In
> the meanwhile I could mail it to anyone interested.

It is now avaible at <URL:http://home.sol.no/~espejohn>. To avoid confuison
with Gilbert Baumann's package with the same name, I have changed the name
to clg. Unfornately I will not be able to answer any messages or mails
regarding this package for the next two months.

-- 
Espen
------- End of forwarded message -------

---

From: Erik Arneson <[email-masked]>
Date: Wed, 15 Mar 2000 08:32:36 -0800 (PST)

> into the standard clisp distribution. :-)

I'd love to see this happen.  Consider me a demanding user.  :)

-- 
# Erik Arneson      [email-masked]    Webring Software Engineer #
# Yahoo! Inc.    GPG Key ID: 1024D/43AD6AB8     (541) 482-3000x114 #
# "The worst wheel of a cart makes the most noise." - Ben Franklin #

---

From: Thibault Langlois <[email-masked]>
Date: Wed, 15 Mar 2000 21:08:12 +0000

| 
| While CLISP already comes with (2 implementations of) CLX, it is
| considered too low-level for easy development.
|

What about Garnet ? I'm a very new Garnet user and I must say that I like it. 
It comes with an excelent doc and several apps, the most usefull being
a GUI builder. Of course some people say it looks ugly...
  
| If there is a sufficient user demand, the developers might think of
| discussing the idea of considering talking about trying to integrate clg
| into the standard clisp distribution. :-)
| 

I don't know clg but I have installed Gilbert Baumann's package.
Does clg follow the same principle (the GUI is running in a separate 
process and controled via sockets) ?
I was wondering what are the advantages of this approach compared with
a binding via a FFI. 
In the case of a separate process, objects of the interface are duplicated
(on the lisp side and on the c side). Am I right ?  

Gilbert Baumann did not use his gtk package for closure (he used clue). Why ?

Thibault Langlois

---

From: Eric Marsden <[email-masked]>
Date: 16 Mar 2000 10:56:20 +0100

>>>>> "tl" == Thibault Langlois <[email-masked]> writes:

  tl> What about Garnet ? I'm a very new Garnet user and I must say
  tl> that I like it. It comes with an excelent doc and several apps,
  tl> the most usefull being a GUI builder. Of course some people say
  tl> it looks ugly...

I've been playing with it recently, and it seems powerful, though
crufty in places (lots of #+), and I'd prefer having native widgets.

It doesn't work correctly with CLISP: with nclx it seems to miss some
refresh events (windows sometimes stay undrawn), and the logo in the
demos section doesn't display in color. It doesn't work at all with
mit-clx (nor indeed do basic CLX demos): there are problems with setf
functions being hidden by setf-expanders:

when loading garnet:

  WARNING:
  The function (SETF XLIB:GCONTEXT-FUNCTION) is hidden by a SETF expander.
  WARNING:
  The function (SETF XLIB:GCONTEXT-FOREGROUND) is hidden by a SETF expander.
  WARNING:
  The function (SETF XLIB:GCONTEXT-BACKGROUND) is hidden by a SETF expander.
  [...]

then when running:

  *** - FUNCALL: the function #:|(SETF XLIB:WINDOW-PLIST)| is undefined

I think the problem is in the mit-clx/depdefs.lsp:def-clx-class macro,
which seems to be emulating CLOS with structures, but it's too hairy
for me to understand.

[CLISP 2000-03-06 and garnet-3.0.clisp]   
   
-- 
Eric Marsden

---

From: Paolo Amoroso <[email-masked]>
Date: Thu, 16 Mar 2000 22:49:34 +0100

> demos section doesn't display in color. It doesn't work at all with

The Garnet logo demo used to work in color for me with CLISP and NCLX, but
I can't confirm it now because I haven't rebuilt Garnet yet.

Paolo
-- 
EncyCMUCLopedia * Extensive collection of CMU Common Lisp documentation
http://cvs2.cons.org:8000/cmucl/doc/EncyCMUCLopedia/